%%%%%%%%%%%%%%%%%%%%%%%%%%%% LOCALIZATION FUNCTIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%

% This function uses a Particle Filter to estimate the robot's position. It
% should return the robot estimated state and the particle set. 
function [X_est_t, P] = localizeRobot(X_est_tm1, O, Z, M, P)

    % Tseful variables
    sigma_O = 0.6*max(abs(O));
    X_pred_i = zeros(size(X_est_tm1,1),size(X_est_tm1,2));

    % Prediction Step
    % X_pred_i = ...
    
    
    
    % Correction Step
    % P = ...
        
    
    
    
    % Calculate State
    % X_est_t = ...
     
    
end



% This function calculates the estimated robot state by taking the average
% of all particle x,y locations. To estimate theta, the mean direction
% vector is calculated, and then converted back to a yaw angle.
function [X_est] = getMeanState(P)
    X_est(1) = mean(P(:,1));
    X_est(2) = mean(P(:,2));
    X_est(3) = atan2(sum(sin(P(:,3))), sum(cos(P(:,3))));
end



% Given a set of particles defined by state and weights, a new
% set of particles is randomly selected, giving more likelihood of being
% selected to particles with higher weights.
function [P]= resample(X_pred_i)

    % Create many copies in a temporary set of particles
    maxNumCopies = 4;
    P_temp = [];
    P=[];
    maxW = max(X_pred_i(:,4));
    sizeP_temp = 0;
    
    % Create a temporary set of particles, and add more copies of particles
    % with higher weights to this set.
    for i=1:size(X_pred_i,1)
        deltaP = ceil(maxNumCopies*X_pred_i(i,4)/maxW);
        for j=sizeP_temp+1:sizeP_temp+1 + deltaP
            P_temp(j,1:4) = X_pred_i(i,1:4);
        end
        sizeP_temp = sizeP_temp + deltaP;
    end
    
    % Draw randomly from the temporary set of particles
    for i=1:size(X_pred_i,1)
        P(i,1:4) = P_temp(randi(size(P_temp,1)),1:4); 
    end
end


% This function should caclulate a particle's weight, i.e. how well a
% particle state matches the most recent measurements
function [w] = getWeight(X, Z, M)

    % A useful parameter
    var_z=0.1;

    % Set the weight
    %w = ...
   
end




